#include <stdio.h>
#include <string.h>

char	*fieldnames[ 32 ];

int db_dumpField( FILE *pfDb )
{
	int	len;
	char	val[ 1024 ];
	int	pos = 0;
	
	len = fgetc( pfDb );
	
	while( pos < len ){
		val[ pos ] = fgetc( pfDb );
		pos++;
	}
	val[ pos ] = 0;
	
	printf( "%s\n", val );	
}

int db_dumpEntry( FILE *pfDb )
{
	int	c = 0;
	
	c = fgetc( pfDb );
	if( c == 0xff ){
		printf( "EMPTY\n" );
		return;
	}
	
	while( ( c != 0xff )&&( !feof( pfDb ) ) ){
		printf( "%s=", fieldnames[ c ] );
		db_dumpField( pfDb );
		c = fgetc( pfDb );
	}
}

int tags_loadNames( )
{
	FILE	*pfTags = NULL;
	char	fieldname[ 1024 ] = "xx";
	int	field = 0;
	
	pfTags = fopen( "tags", "rb" );
	while( strlen( fieldname )>1 ){
		fgets( fieldname, 1023, pfTags );
		fieldname[ strlen( fieldname )-1 ] = 0;
		fieldnames[ field++ ] = strdup( fieldname );
	}
}

int main( )
{
	FILE	*pfDb = NULL;
	int	iFid = 0x0;
	
	tags_loadNames( );
	
	pfDb = fopen( "database", "rb" );
	
	while( !feof( pfDb ) ){
		printf( "-----------------------------------------\n" );
		printf( "FID: %08x\n", iFid );
		db_dumpEntry( pfDb );
		iFid += 16;
	}
	
	fclose( pfDb );	
}